class Client

  attr_accessor :instance, :client_id, :client_secret, :username, :password, :security_token, :bearer_token

  @@bearer_token_retrieve_time = 3300

  # def init()
  #
  # end

  # def init(instance, client_id, client_secret, username, password, security_token)
  #   unless instance.nil? or client_id.nil? or client_secret.nil? or usenrame.nil? or password.nil? or security_token.nil?
  #     @instance = instance
  #     @client_id = client_id
  #     @client_secret = client_secret
  #     @username = username
  #     @password = password
  #     @security_token = security_token
  #   else
  #     raise "Unable to instantiate a client - instance, client_id, client_secret, username, password, or security_token are nil."
  #   end
  #
  #   retrieve_and_refresh_bearer_token
  # end

  def retrieve_and_refresh_bearer_token
    oauth_url = "https://%s.salesforce.com/services/oauth2/token" % [@instance]
    data = {
      "grant_type": "password",
      "client_id": @client_id,
      "client_secret": @client_secret,
      "username": @username,
      "password": "%s%s" % [@password, @security_token]
    }

    response = RestClient.post oauth_url, data
    response_json = JSON.parse(response.body)

    @bearer_token = response_json["access_token"]
  end

  # private :retrieve_and_refresh_bearer_token
end